function love.load()
    love.window.setFullscreen(true)
    x = love.graphics.getWidth()/2
    y = love.graphics.getHeight()/2
    draw_things = {}
    --x, y, size, ispixel
    size = 4
    ispixel = false
    mirror = 0
    pendown = false
    speed = 4
    info = true
    swap = false
    up = false
    down = false
    left = false
    right = false
    change_size = 0
    change_speed = 0
    screenshot_taking = false
    love.filesystem.setIdentity('HardData');
    screenshots = 1
end

function love.update(dt)
    if change_size == 0.1 then
        if size < 100 then
            size = size + change_size
        end
    elseif change_size == -0.1 then
        if size > 0.5 then
            size = size + change_size
        end
    end
    if change_speed == 0.1 then
        if speed < 50 then
            speed = speed + change_speed
        end
    elseif change_speed == -0.1 then
        if speed > 0.5 then
            speed = speed + change_speed
        end
    end
    if up == true then
        if y+speed > 0 then
            y = y - speed
        else
            y = 0
        end
    end
    if left == true then
        if x+speed > 0 then
            x = x - speed
        else
            x = 0
        end
    end
    if down == true then
        if y+speed < love.graphics.getHeight() then
            y = y + speed
        else
            y = love.graphics.getHeight()
        end
    end
    if right == true then
        if x+speed < love.graphics.getWidth() then
            x = x + speed
        else
            x = love.graphics.getWidth()
        end
    end
    if pendown == true then
        if mirror == 0 then
            draw_things[#draw_things+1] = {x, y, size, ispixel}
        elseif mirror == 1 then
            draw_things[#draw_things+1] = {x, y, size, ispixel}
            draw_things[#draw_things+1] = {love.graphics.getWidth() - x, y, size, ispixel}
        elseif mirror == 2 then
            draw_things[#draw_things+1] = {x, y, size, ispixel}
            draw_things[#draw_things+1] = {love.graphics.getWidth() - x, y, size, ispixel}

            draw_things[#draw_things+1] = {x, love.graphics.getHeight() - y, size, ispixel}
            draw_things[#draw_things+1] = {love.graphics.getWidth() - x, love.graphics.getHeight() - y, size, ispixel}
        end
    end 
end

function love.conf(t)
    t.screen.width = love.graphics.getWidth()
    t.screen.height = love.graphics.getHeight()
    t.identity = "sheets"
    t.console = true
end

function love.draw()
    if screenshot_taking == false then
        if swap == true then
            love.graphics.setColor(1,1,1)
            love.graphics.setBackgroundColor(0,0,0)
        else
            love.graphics.setColor(0,0,0)
            love.graphics.setBackgroundColor(1,1,1)
        end
        if ispixel == true then
            temp_ispixel = 0
        else
            temp_ispixel = 100
        end
        if mirror == 0 then
            love.graphics.rectangle("line", x-(size+4)/2, y-(size+4)/2, size + 4, size + 4, temp_ispixel)
            love.graphics.rectangle("line", x-(size+4)/2-1, y-(size+4)/2-1, size + 4+2, size + 4+2, temp_ispixel)
        elseif mirror == 1 then
            love.graphics.rectangle("line", x-(size+4)/2, y-(size+4)/2, size + 4, size + 4, temp_ispixel)
            love.graphics.rectangle("line", x-(size+4)/2-1, y-(size+4)/2-1, size + 4+2, size + 4+2, temp_ispixel)
            love.graphics.rectangle("line", love.graphics.getWidth() - x-(size+4)/2, y-(size+4)/2, size + 4, size + 4, temp_ispixel)
        elseif mirror == 2 then
            love.graphics.rectangle("line", x-(size+4)/2, y-(size+4)/2, size + 4, size + 4, temp_ispixel)
            love.graphics.rectangle("line", x-(size+4)/2-1, y-(size+4)/2-1, size + 4+2, size + 4+2, temp_ispixel)
            love.graphics.rectangle("line", love.graphics.getWidth() - x-(size+4)/2, y-(size+4)/2, size + 4, size + 4, temp_ispixel)
            
            love.graphics.rectangle("line", x-(size+4)/2, love.graphics.getHeight() - y-(size+4)/2, size + 4, size + 4, temp_ispixel)
            love.graphics.rectangle("line", love.graphics.getWidth() - x-(size+4)/2, love.graphics.getHeight() - y-(size+4)/2, size + 4, size + 4, temp_ispixel)
        end
        if info == true then
            love.graphics.setColor(0.6,0.6,0.6)
            love.graphics.rectangle("fill", 10, 10, 400, 205, 6) -- max+15
            love.graphics.setColor(1,1,1)
            love.graphics.print("Right now there's placed "..mirror.." mirror(s)", 20, 20)
            love.graphics.print("Change amount of mirrors with m", 20, 30)
            love.graphics.print("Speed: "..speed, 20, 50)
            love.graphics.print("Change speed with arrows(up/down)", 20, 60)
            love.graphics.print("Size: "..size, 20, 80)
            love.graphics.print("Change speed with arrows(left/right)", 20, 90)
            if pendown == true then
                love.graphics.print("Pen is down", 20, 110)
            else
                love.graphics.print("Pen is up", 20, 110)
            end
            love.graphics.print("This can be changed with q", 20, 120)
            if ispixel == true then
                love.graphics.print("You are drawing with squares", 20, 140)
            else
                love.graphics.print("You are drawing with circles", 20, 140)
            end
            love.graphics.print("This can be changed with o", 20, 150)
            love.graphics.print("Simple change color with c", 20, 170)
            love.graphics.print("To toggle show/hide this press i", 20, 190)


        end
        if swap == true then
            love.graphics.setColor(1,1,1)
        else
            love.graphics.setColor(0,0,0)
        end
        for i = 1,#draw_things do
            if draw_things[i][4] == true then
                love.graphics.rectangle("fill", draw_things[i][1] - draw_things[i][3]/2, draw_things[i][2] - draw_things[i][3]/2, draw_things[i][3], draw_things[i][3])
            else
                love.graphics.rectangle("fill", draw_things[i][1] - draw_things[i][3]/2, draw_things[i][2] - draw_things[i][3]/2, draw_things[i][3], draw_things[i][3], 100)
            end
        end
    else
        if swap == true then
            love.graphics.setColor(1,1,1)
            love.graphics.setBackgroundColor(0,0,0)
        else
            love.graphics.setColor(0,0,0)
            love.graphics.setBackgroundColor(1,1,1)
        for i = 1,#draw_things do
            if draw_things[i][4] == true then
                love.graphics.rectangle("fill", draw_things[i][1] - draw_things[i][3]/2, draw_things[i][2] - draw_things[i][3]/2, draw_things[i][3], draw_things[i][3])
            else
                love.graphics.rectangle("fill", draw_things[i][1] - draw_things[i][3]/2, draw_things[i][2] - draw_things[i][3]/2, draw_things[i][3], draw_things[i][3], 100)
            end
        end
        screenshot = love.graphics.newScreenshot( )
        screenshot:encode('png', os.time() .. '.png')
        screenshot_taking = false
        end
    end
end

function love.keypressed(key)
    if key == "m" then
        mirror = mirror + 1
        if mirror == 3 then
            mirror = 0
        end
    end
    if key == "r" then
        draw_things = {}
    end
    if key == "q" then
        if pendown == false then
            pendown = true
        else
            pendown = false
        end
    end
    if key == "c" then
        if swap == true then
            swap = false
        else
            swap = true
        end
    end
    if key == "o" then
        if ispixel == true then
            ispixel = false
        else
            ispixel = true
        end
    end
    if key == "i" then
        if info == true then
            info = false
        else
            info = true
        end
    end
    if key == "f" then
        screenshot_taking = true
    end
    if key == "up" then
        change_speed = change_speed + 0.1
    end
    if key == "down" then
        change_speed = change_speed - 0.1
    end
    if key == "left" then
        change_size = change_size - 0.1
    end
    if key == "right" then
        change_size = change_size + 0.1
    end
    if key == "w" then
        up = true
    end
    if key == "s" then
        down = true
    end
    if key == "a" then
        left = true
    end
    if key == "d" then
        right = true
    end
end

function love.keyreleased(key)
    if key == "up" then
        change_speed = change_speed - 0.1
    end
    if key == "down" then
        change_speed = change_speed + 0.1
    end
    if key == "left" then
        change_size = change_size + 0.1
    end
    if key == "right" then
        change_size = change_size - 0.1
    end
    if key == "w" then
        up = false
    end
    if key == "s" then
        down = false
    end
    if key == "a" then
        left = false
    end
    if key == "d" then
        right = false
    end
end